package cn.com.infosec.mobile.android.algorithm;

import android.support.annotation.Keep;
import java.util.Arrays;

@Keep
public class HmacSM3 {
   private int B = 64;
   private byte[] k1;
   byte[] ipad = new byte[64];
   byte[] opad = new byte[64];
   byte[] step1Data;
   private SM3 sm3 = new SM3();

   public HmacSM3(byte[] key) {
      if (key == null || key.length <= 0) {
         key = new byte[16];
      }

      int var2;
      int var3;
      for(var2 = 0; var2 < (var3 = this.B); ++var2) {
         this.ipad[var2] = 54;
         this.opad[var2] = 92;
      }

      if (key.length > var3) {
         key = this.sm3.digest(key);
      }

      byte[] var10000 = key;
      byte[] var10001 = key;
      byte[] var10002 = key;
      this.k1 = key = new byte[this.B];
      var2 = var10002.length;
      System.arraycopy(var10001, 0, key, 0, var2);

      byte[] var5;
      for(int key1 = var10000.length; key1 < (var5 = this.k1).length; ++key1) {
         var5[key1] = 0;
      }

      this.prepare();
   }

   private void prepare() {
      this.step1Data = new byte[this.B];

      for(int var1 = 0; var1 < this.B; ++var1) {
         this.step1Data[var1] = (byte)((this.k1[var1] ^ this.ipad[var1]) & 255);
      }

   }

   public byte[] doFinal(byte[] plain) {
      if (plain != null && plain.length > 0) {
         byte[] var10002 = plain;
         byte[] var10003 = plain;
         byte[] var10005 = this.step1Data;
         plain = Arrays.copyOf(var10005, var10005.length + plain.length);
         int var2 = this.step1Data.length;
         int var3 = var10003.length;
         System.arraycopy(var10002, 0, plain, var2, var3);
         plain = this.sm3.digest(plain);
         byte[] var6 = new byte[var2 = this.B];

         int var5;
         for(int var4 = 0; var4 < (var5 = this.B); ++var4) {
            var6[var4] = (byte)((this.k1[var4] ^ this.opad[var4]) & 255);
         }

         byte[] var10001 = plain;
         var10002 = plain;
         plain = new byte[var5 + plain.length];
         System.arraycopy(var6, 0, plain, 0, var2);
         var3 = var10002.length;
         System.arraycopy(var10001, 0, plain, var2, var3);
         byte[] var10000 = this.sm3.digest(plain);
         this.prepare();
         return var10000;
      } else {
         return null;
      }
   }
}
